num2hex : n
{
	// Convert a positive integer to a hex digit string.

	// credit: Ernie Wright
	
	var a, ndigits, e, i, d;

	if ( n < 1 ) return "0";

	ndigits = integer( ceil( log( n ) / log( 16.0 )));
	e = integer( pow( 16, ndigits - 1 ));
	a = "";

	for ( i = 1; i <= ndigits; i++ )
	{
		d = integer( floor( n / e ));
		if ( d <= 9 )
		a += string( d );
		else switch ( d )
		{
			case 10:  a += "A";  break;
			case 11:  a += "B";  break;
			case 12:  a += "C";  break;
			case 13:  a += "D";  break;
			case 14:  a += "E";  break;
			case 15:  a += "F";  break;
		}
		n -= d * e;
		e /= 16;
	}

	return a;
}
